<style type="text/css">
    @keyframes ldio-o2q9zue8yh {
        0% { transform: rotate(0deg) }
        50% { transform: rotate(180deg) }
        100% { transform: rotate(360deg) }
    }
    .ldio-o2q9zue8yh div {
        position: absolute;
        animation: ldio-o2q9zue8yh 1.3800000000000001s linear infinite;
        width: 144.8px;
        height: 144.8px;
        top: 18.1px;
        left: 18.1px;
        border-radius: 50%;
        box-shadow: 0 3.62px 0 0 #48d610;
        transform-origin: 72.4px 74.21000000000001px;
    }
    .loadingio-spinner-eclipse-kzut9ayjehg {
        width: 181px;
        height: 181px;
        display: inline-block;
        overflow: hidden;
        background: rgba(NaN, NaN, NaN, 0);
    }
    .ldio-o2q9zue8yh {
        width: 100%;
        height: 100%;
        position: relative;
        transform: translateZ(0) scale(1);
        backface-visibility: hidden;
        transform-origin: 0 0; /* see note above */
    }
    .ldio-o2q9zue8yh div { box-sizing: content-box; }
    /* generated by https://loading.io/ */
</style>
<div class="content-heading">
    <div class="heading-left">
        <h1 class="page-title">Blank Page</h1>
        <p class="page-subtitle">Create your new page based on this starter page.</p>
    </div>
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="#"><i class="fa fa-home"></i> Home</a></li>
            <li class="breadcrumb-item"><a href="#">Parent</a></li>
            <li class="breadcrumb-item active">Current</li>
        </ol>
    </nav>
</div>

<div id="contenedor-vue" class="container-fluid">
    <div class="card">
        <div class="card-header">
            <div class="row">
                <div class="col-md-5"><h3>Lista De Clientes</h3></div>
                <div class="col-md-7 text-right">
                    <button  data-toggle="modal" data-target="#exampleModal" class="btn btn-primary">Enviar Mensaje</button>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-md-12">
                    <button  data-toggle="modal" data-target="#registro-cliente"  class="btn btn-primary">Agregar Cliente</button>
                </div>
            </div>
            <br>
            <table id="table_lista_cliente" class="table table-striped table-bordered" style="width:100%">
                <thead>
                <tr>
                    <th class="text-center">#</th>
                    <th class="text-center">Nombres</th>
                    <th class="text-center">Cod Pais</th>
                    <th class="text-center">Celular</th>
                    <th class="text-center"></th>
                </tr>
                </thead>
                <tbody>

                </tbody>
            </table>
        </div>
    </div>
    <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Mensaje Enviar</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form v-on:submit.prevent="enviar_mensaje">
                    <div class="modal-body">
                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label>Tipo Mensaje</label>
                                    <select v-model="tipo_mensaje" class="form-control">
                                        <option value="1">Texto</option>
                                        <option value="2">Archivo o Foto</option>
                                    </select>
                                </div>
                                <div v-if="tipo_mensaje==1" class="form-group">
                                    <label>Mensaje</label>
                                    <textarea required id="mensaje" class="form-control" ></textarea>
                                </div>
                                <div v-if="tipo_mensaje==2" class="form-group">
                                    <label>Archivo o Foto</label>
                                    <input required id="archivo" class="form-control" type="file" >
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button  type="submit" class="btn btn-primary">Enviar</button>
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    </div>
                </form>

            </div>
        </div>
    </div>

    <div class="modal fade" id="preparar-envio" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Preparando envio</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                    <div class="modal-body">
                        <div class="text-center" ><h1 id="mensaje-ser-ws">Espere mientras cargar el Servicio</h1></div>
                        <div class="row">
                            <div id="cont-qr-cod" style="display: block;margin: auto;"></div>
                        </div>
                        <div id="loader-ws-s" style="display: none">
                            <div style="margin: auto;display: block;" class="loadingio-spinner-eclipse-kzut9ayjehg">
                                <div class="ldio-o2q9zue8yh">
                                    <div></div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    </div>

            </div>
        </div>
    </div>

    <div class="modal fade" id="registro-cliente" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Preparando envio</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form  v-on:submit.prevent="registrar_cliente">
                <div class="modal-body">
                     <div class="container">

                             <div class="form-group">
                                 <label for="exampleInputEmail1">Nombre</label>
                                 <input v-model="cliente.nombre" required type="text" class="form-control"  placeholder="Nombre">

                             </div>
                             <div class="form-group">
                                 <label >Celular</label>
                                 <div class="input-group ">
                                     <div class="input-group-prepend">
                                         <div class="input-group-text">+51</div>
                                     </div>
                                     <input v-model="cliente.numero" required type="text" class="form-control"  placeholder="0000000">
                                 </div>
                             </div>

                         </div>
                </div>
                <div class="modal-footer">
                    <button type="submit" class="btn btn-primary">Registrar</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
        </form>
            </div>
        </div>
    </div>


</div>
<script>
    var socket;
    var qrcode;
    var APP;
    var tabla_cliente;
    var lista_temp=[];

    function listar_clientes(){
        lista_temp=[];
        _ajax("/cliente/lista","POST",{},function (resp){
            $("#table_lista_cliente tbody").html('')
            var row_html="";
            resp.forEach(function (item){
                row_html+='<tr>' +
                    '<td class="text-center"></td>' +
                    '<td class="text-center">'+item.nombres+'</td>' +
                    '<td class="text-center">'+item.doc_pais+'</td>' +
                    '<td class="text-center">'+item.celular+'</td>' +
                    '<td class="text-center"><input onchange="checkec_cliente(event)" class="check-cliente" type="checkbox" value="'+item.cliente_id+'"></td>' +
                    '</tr>';
            })
            $("#table_lista_cliente tbody").html(row_html)
        })
    }

    function checkec_cliente(evt){
        const elm = $(evt.target);
        if (elm.is(":checked")){
            lista_temp.push(elm.val())
        }else{
            const ind = lista_temp.indexOf(elm.val());
            lista_temp.splice(ind, 1);
        }
    }
    function enviar_mensaje(){
        _ajax("/cliente/enviar/mensaje","POST",
            {mesnaje:$("#mensaje").val(),lista:JSON.stringify(lista_temp)},
            function (resp){
                console.log(resp);
            }
        )
    }
    $(document).ready(function() {
        listar_clientes()
        //tabla_cliente=$('#example').DataTable();
        socket = io("localhost:3001");
        socket.on("genQrcliente",function (data){
            $("#loader-ws-s").hide();
            $("#mensaje-ser-ws").text("Escanee este codigo QR con Whatsapp");
            console.log(data);
            if (!qrcode){
                qrcode = new QRCode(document.getElementById("cont-qr-cod"),data.qr)
            }else{
                qrcode.clear(); // clear the code.
                qrcode.makeCode(data.qr);
            }
        })

        socket.on("cliente-auth-ready",function (data){
            $("#loader-ws-s").show();
            $("#mensaje-ser-ws").text("Autenticacion Realizada");
            //setTimeout(function (){APP.enviar_mensaje_fin();},1000)
        })
        socket.on("cliente-auth",function (data){
            console.log(data);
            if (data.res){
                _ajax("/ajs/save/session","POST",{session:JSON.stringify(data.auth)},function (resp){
                        console.log(resp);
                    }
                )
                qrcode =null;
                $("#cont-qr-cod").html("")
                setTimeout(function (){APP.enviar_mensaje_fin();},1000)
            }else{
                $("#mensaje-ser-ws").text("Error al autenticar: Reitentando");
                socket.emit("conectar-ws-serv",{res:false})
            }

        })
        socket.on("envio-completo",function (data){
            console.log(data);
            $("#preparar-envio").modal("hide")
            alertExito("Envidao","mensaje enviado")
        })
       APP=new Vue({
            el:'#contenedor-vue',
            data:{
                cliente:{
                    nombre:'',
                    numero:'',
                    file:'',
                },
                tipo_mensaje:'',
                lista_cliente:[]
            },
            methods:{
                subir_file_upload(fun=function (){}){
                    var fd = new FormData();
                    fd.append('file',$("#archivo")[0].files[0]);
                    $.ajax({
                        xhr: function() {
                            var xhr = new window.XMLHttpRequest();
                            xhr.upload.addEventListener("progress", function(evt) {
                                if (evt.lengthComputable) {
                                    var percentComplete = ((evt.loaded / evt.total) * 100);
                                    $('.progress-bar').css('width', percentComplete+'%').attr('aria-valuenow', percentComplete);

                                }
                            }, false);
                            return xhr;
                        },
                        type: 'POST',
                        url: _URL+'/upd/file/wsv',
                        data: fd,
                        contentType: false,
                        cache: false,
                        processData:false,
                        beforeSend: function(){
                            console.log('inicio');
                            $(".progress").show()
                            $('.progress-bar').css('width', 0+'%').attr('aria-valuenow', 0);
                        },
                        error:function(err){
                            $("#loader-menor").hide();
                            console.log(err);
                            alertAdvertencia("Alerta", "No se pudo subir el archivo");
                        },
                        success: function(resp){
                            $("#loader-menor").hide();
                            console.log(resp);
                            resp=JSON.parse(resp);
                            if (resp.res){
                                fun(resp)
                                //$("#fil-doc-tempp").val(resp.dstos)
                               // $("#header-perfil-foto").attr("src",_URL+"/public/img/usuarios/"+resp.dstos)
                                /*$("#fil-doc-tempp-a").attr("target","_blank")*/
                            }else{
                                alertAdvertencia("Alerta", "No se pudo subir el archivo");
                            }
                        }
                    });
                },
                registrar_cliente(){
                    const preD={...this.cliente}
                    _ajax("/cliente/registrar","POST",preD,function (resp){
                        console.log(resp);
                        if (resp.res){
                            $("#registro-cliente").modal("hide")
                            listar_clientes()
                        }else{
                            alertAdvertencia("Alerta","no se pudo agregar")
                        }

                    })
                },
                enviar_mensaje_fin(){
                    $("#mensaje-ser-ws").text("Enviando mensajes");
                    console.log('enviando')
                    if (this.tipo_mensaje==1){
                        socket.emit("enviar-mensaje-tex",{mensaje:$("#mensaje").val(),numero:this.lista_cliente})
                    }else if (this.tipo_mensaje==2){
                        socket.emit("enviar-mensaje-file",
                            {file:this.cliente.file,
                                numero:this.lista_cliente})
                    }
                },
                continuar_envio(lista){
                    this.lista_cliente= lista;
                    $("#exampleModal").modal("hide")
                    $("#preparar-envio").modal("show")
                    $("#mensaje-ser-ws").text("Espere mientras cargar el Servicio");
                    $("#loader-ws-s").show();
                    _ajax("/ajs/get/session","POST",{},
                        function (resp){
                            console.log(resp);
                            if (resp.res){
                                $("#mensaje-ser-ws").text("Autentificando Sesion Con Whatsapp");
                            }else{
                                $("#mensaje-ser-ws").text("Conectadon con Whatsapp");
                            }
                            socket.emit("conectar-ws-serv",resp)
                        }
                    )

                },
                enviar_mensaje(){
                   if (this.tipo_mensaje.length>0){
                       if (socket.connected){
                           $("#loader-menor").show();
                           //console.log(lista_temp)
                           if (this.tipo_mensaje==2){
                               this.subir_file_upload(function (resp){
                                   console.log(resp);
                                   APP._data.cliente.file=resp.dstos
                                   _ajax("/cliente/lista/consul","POST",
                                       {lista:JSON.stringify(lista_temp)},
                                       function (resp){
                                           console.log(resp);
                                           APP.continuar_envio(resp);
                                       })
                               })
                           }else{
                               _ajax("/cliente/lista/consul","POST",
                                   {lista:JSON.stringify(lista_temp)},
                                   function (resp){
                                       console.log(resp);
                                       APP.continuar_envio(resp);
                                   })
                           }
                           /*_ajax("/cliente/lista/consul","POST",
                               {lista:JSON.stringify(lista_temp)},
                               function (resp){
                                   console.log(resp);
                                   APP.continuar_envio(resp);
                               }
                           )*/
                       }else{
                           alertAdvertencia("Alerta","No de pudo conectar con el Servidor")
                       }
                   } else{
                       alertAdvertencia("Alerta","Elija el tipo de mensaje")
                   }
                }
            }
        });

    } );

</script>